=== debian/changelog ===
geographiclib (1.52-1) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 15 Aug 2021 10:03:27 +0200

geographiclib (1.52-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.5.1, no changes.
  * Don't bother with duplicate Doxygen files.
    (closes: #988742)
  * Update copyright file.
  * Refresh patches.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 22 Jun 2021 15:49:18 +0200
